
// BKMEM_testDlg.h : файл заголовка
// !!!доработать

#pragma once
#include <afxcmn.h>
#include "resource.h"
#include "16KPageContainer.h"
#include "LockVarType.h"

// диалоговое окно CBKMEM_Dlg

class CBKMEM_Dlg : public CDialogEx
{
		DECLARE_DYNAMIC(CBKMEM_Dlg)
		// Создание
	public:
		CBKMEM_Dlg(BOARD_MODEL nBKModel, BKFDD_MODEL nBKFDDModel, BYTE *MainMem, BYTE *AddMem, CWnd *pParent = nullptr);
		virtual ~CBKMEM_Dlg();
		// Данные диалогового окна

		enum
		{
			IDD = IDD_BKMEM_MAP_DIALOG
		};

		void CreateTabs_10();
		void CreateTabs_11M();
		void AddTabsA16M();
		void AddTabsSMK512();
		void DrawTab();

	protected:
		virtual void DoDataExchange(CDataExchange *pDX) override;   // поддержка DDX/DDV
		void AdjustTab();

		// Реализация
	protected:
		//HICON m_hIcon;
		BYTE *m_Memory;
		BYTE *m_MemoryADD;
		BOARD_MODEL m_BKModel;
		BKFDD_MODEL m_BKFDDmodel;
		/*
		для конфигурации БК10 - 1 вкладка: 0 и 1 страницы (1 - экран)
		для конфигурации БК11 - 4 вкладки: 8 страниц, по 2 шт. во вкладке
		для A16M - вкладка, с одной страницей. (добавить реализовать такую возможность)
		для смк512 - 16 вкладок
		*/
		unsigned int m_nTabsCount;
		int m_nSelectedTab;

		C16KPageContainer *m_pContainers[20]; //массив окон во вкладках.

		CTabCtrl m_tab;

		// Созданные функции схемы сообщений
		virtual BOOL OnInitDialog() override;
		virtual void OnCancel() override;
		afx_msg void OnTcnSelchangeTab1(NMHDR *pNMHDR, LRESULT *pResult);
		DECLARE_MESSAGE_MAP()
};


// представление формы CBKMEMView

class CBKMEMView : public CFrameWnd
{
		DECLARE_DYNAMIC(CBKMEMView)

		CBKMEM_Dlg *m_pdlgBKMem;

		LockVarType m_lockStop, m_lockDraw;

	public:
		CBKMEMView(BOARD_MODEL nBKModel, BKFDD_MODEL BKFDDmodel, BYTE *MainMem, BYTE *AddMem);
		virtual ~CBKMEMView() override;
		void DrawCurrentTab();

	protected:
		afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
		afx_msg void OnDestroy();
		DECLARE_MESSAGE_MAP()
};

